package com.u6f6o.education.code_kata.prime_factors;

import java.util.ArrayList;
import java.util.List;

/**
 * Created with IntelliJ IDEA.
 * User: u6f6o
 * Date: 12/07/12
 * Time: 22:00
 * To change this template use File | Settings | File Templates.
 */
public class PrimeFactoryKata {
    public List<Integer> getPrimeFactors( int number ) {
        List<Integer> result = new ArrayList<Integer>();

        if( number < 2 ) return result;
        int smallestDivisor = findSmallestDivisor( number );

        result.add( smallestDivisor );
        result.addAll( getPrimeFactors( number / smallestDivisor ));

        return result;
    }

    private int findSmallestDivisor( final int number ) {
        for( int i = 2; i <= Math.sqrt( number ); i++ ) {
            if( number % i == 0 ) return i;
        }
        return number;
    }
}
